#include <BluetoothSerial.h>
#if !defined(CONFIG_BT_ENABLED) || !defined(CONFIG_BLUEDROID_ENABLED)
#error Bluetooth is not enabled! Please run `make menuconfig` to and enable it
#endif
BluetoothSerial SerialBT;

#include "defin.h"
#include "gyro_acsel.h"
#include "step_motor.h" // Обслуживание шаговых моторов
#include "fromsmart.h" // Обслуживание шаговых моторов


double   _1_d_131 = 1.0 * DEG_TO_RAD / 131.0;
double Acsel = 0;
double Gyro = 0;

void setup() {
  setup_motor_system();
  Serial.println("Do");
  motor_off();

  Serial.begin(115200);
  Serial.println();

  SerialBT.begin("BARSIK"); //Имя робота в BT
  giroscop_setup();
  delay(100);
  Calc_CompensatorZ(2000);
  t0 = micros() - 5000;
  t2 = micros();
  Speed = 0;
}

void loop()
{
  t_period = 5000;
  static int i = 0; // для торможения вывода
  uint64_t micros_;
  micros_ = micros();
  if (micros_ < t2) return;//Если период < t2 анализ. прошло 5000 если да, измеряем угловую скорость.
  BT_input();
  //Опрос гироприбора:
  //bno.getEvent(&event); // Берем сразу углы Эйлера
  dt = micros() - t0; // Длительность предыдущего периода регулирования.
  t0 += dt; //Точка начала нового периода регулирования.
  double Dt = double(dt) * 0.000001;
  // Нужно поймать угол, рядом с которым угловая скорость колеблется в районе нуля.
  OldAcYsum = AcYsum;
  Data_mpu6050();
  //Расчет угла по показаниям акселерометра
   Acsel = (atan2(AcX, AcZ));// * RAD_TO_DEG;
   // скорость угловая В радианах - падения
   Gyro = - (float(GyY) - CompensatorY)  * _1_d_131; 
   //Комплементарный фильтр
  AcYsum = ONE_ALFA * (OldAcYsum + Gyro * Dt) + ALFA * Acsel;
  t2 = t0 + t_period;
//  if (i > 20)
//  {
//    i = 0;
//    Serial.print("GYRO="); Serial.print(Gyro);
//    Serial.print("    Acsel="); Serial.print(Acsel);
//    Serial.print("    AcYsum ="); Serial.print(AcYsum);
//
//    Serial.println();
//  }
//  i++;

  if (time_start_move > micros_) return;
  if (flag_crash)
  {
    if (abs(AcYsum * RAD_TO_DEG) < 15)
    {
      Speed = 0;
      Move = 0;
      //AcYsum = 0;
      OldSpeed = 0;
      flag_crash = false;
      SetSpeed();
      motor_on();
      //return;
    }
  }

  XL = counter_stepL; counter_stepL = 0;
  XR = counter_stepR; counter_stepR = 0;
  XSpeedL =  SpeedL;// double(XL) / Dt; //Реальная скорость колес L //SpeedL;//
  XSpeedR =  SpeedR;//double(XR) / Dt; //Реальная скорость колес R //SpeedR;//
  XSpeed =  (XSpeedL + XSpeedR) * 0.5; //Реальная скорость колес

  Move += Dt * (XSpeed - OldCommandSpeed); //Это как раз пройденный путь

 if ((abs(XSpeed - OldCommandSpeed) + maxSpeed * 0.1) > maxSpeed) //Если вошли в критичный режим
  {
    XSpeed = 0;
    OldCommandSpeed = 0;
    CommandSpeed = 0;
    Move = 0;
    SpeedL = 0;
    SpeedR = 0;
    OldXSpeedL = SpeedL;
    OldXSpeedR  = SpeedR;
    Speed = 0;
    //t_period = 5000;
    //t2 = t0 + t_period;
    SetSpeed();
    Turn = 0; TurnOld = 0;
    time_start_move = millis() + 1000; //Секунда на стабилизацию
    return;
  }
  else
  {
    dSpeedL = (XSpeedL - OldXSpeedL) / Dt;
    dSpeedR = (XSpeedR - OldXSpeedR) / Dt;
    OldXSpeed = XSpeed;
    double DT = CommandSpeed - OldCommandSpeed;
    DT = constrain(DT, -20, 20);
    OldCommandSpeed += DT;
    Speed = (AcYsum) *  6.0 * 800.0 * 20.0 / (2 * PI * 40.0) + 19.0  * Gyro * 800.0 / (40.0 * 2 * PI) + XSpeed + Move * 0.13 + (XSpeed - OldCommandSpeed) * 0.056; // - dSpeed * 0.002; //
    OldXSpeedL = SpeedL;
    OldXSpeedR  = SpeedR;
    DT = Turn - TurnOld;
    DT = constrain(DT, -20, 20);
    TurnOld += DT;
    SpeedL = Speed - dSpeedL * 0.002 + TurnOld;
    SpeedR = Speed - dSpeedR * 0.002 - TurnOld;
    Speed = (SpeedL + SpeedR) * 0.5;
    if (fabs(Speed) < 10.0) //Стабильное значение интегрального звена
    {
      MoveStab = MoveStab * 0.99 + 0.01 * Move;
    }
  }
  // OldCommandSpeed = CommandSpeed; //
  //Speed - это число шагов в секунду
  //Нужно именять длительность периода подстраиваясь под шаг, чтобы был сделан хотябы один шаг.

  double RealSpeed;
  if (fabs(SpeedL) < 10.0)
  {
    SpeedL = 0;
  }
  else
  {
    SpeedL = constrain(SpeedL, -maxSpeed, maxSpeed);
  }
  if (fabs(SpeedR) < 10.0)
  {
    SpeedR = 0;
  }
  else
  {
    SpeedR = constrain(SpeedR, -maxSpeed, maxSpeed);
  }

  RealSpeed = (SpeedR + SpeedL) * 0.5;

  SetSpeed();
  
}

bool stay_from_off() //Встать из положения сидя/лежа
{

}
